<?php
/*
Plugin Name: FavParser
Plugin URI: http://www.emcode.net
Description: This plugin parses posts and adds favicon to every external link it finds, next to it. Liven up your links!
Version: 1.1
Author: Ivan Ciric
Author URI: http://www.emcode.net
License: GPL2
*/
/*  Copyright 2012  Ivan Ciric  (email : office@emcode.net)
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/* Version check */
global $wp_version;

$exit_msg = 'FavParser requires WordPress 2.5 or newer.
    <a href="http://codex.wordpress.org/Upgrading_WordPress">Please update</a>';

if(version_compare($wp_version, '2.5','<')){
    
    exit ($exit_msg);
    
}

register_activation_hook( __FILE__, array('favparser', 'putFavicon'));
add_filter( 'the_content', array('favparser', 'putFavicon'), 5);

class favparser{

    /**
     * @global string $wp_query
     * @return string $text Post contents with favicons added next to links
     */
    public static function putFavicon(){

        //call WP global variable
        global $wp_query;

        //We get the contents of the current post and put it in $text variable
        $text = $wp_query->post->post_content;

        //we define the regular expression as a pattern for search
        $pattern = '/<a\s[^>]*href=(\"??)(http[^\" >]*?)\\1[^>]*>(.*)<\/a>/siU';

        //we check for all the matches of the defined pattern in the post contents
        //and put all the matches in the $matches array
        preg_match_all($pattern, $text, $matches);

        
        $i = 0;

            //itterate thru matches array
            foreach($matches[0] as $value){


                //this is the url matched in the search
                $url = $matches[0][$i];

                //we remove all the html link markup so that we end up with just
                //http:// form of link, because http://g.etfv.co/ service accepts
                //this format only
                $urlClean = str_replace('<a href="','',$url);

                $urlClean2 = str_replace("</a>","",$urlClean);
		$urlClean2 = str_replace('"',"'",$urlClean2);
		$urlClean2 = str_replace('>',"/>",$urlClean2);
                
                //we create html markup which includes the favicon as image next to link
                $favicon = "<img src='http://g.etfv.co/";
                $favicon .= $urlClean2;
                $favicon = substr($favicon, 0, stripos($favicon, ">") );
                $favicon .='>';
		$favicon .= ' '.$url;

                //we replace the original url with the url with img source as favicon
                //next to it
                $replaced = str_replace($url, $favicon, $text);

                //we make this changed post contents, default post contents so 
                //that the next time this loop runs it makes changes to the already
                //modified text
                $text = $replaced;

		$i++;	

            }
    //return post contents to be displayed
    return $text;

    }

}
?>